# How to contribute

There are lots of ways to contribute to Blazor and we appreciate the help from the community. You can provide feedback, report bugs, give suggestions, contribute code, and participate in the discussion.

## Code of conduct

To better foster an open, innovative and inclusive community please refer to our [Code of Conduct](https://github.com/aspnet/Blazor/blob/dev/CODE_OF_CONDUCT.md) when contributing.

## Provide feedback

Since Blazor is currently an experimental project, its primary focus at this time is to explore potential long term directions and to collect feedback. We rely on feedback from users and the community to help us determine if Blazor is heading in the right direction. We want to hear about your experience, scenarios, and requirements.

### Report a bug

If you think you've found a non-security related bug, please log a new issue in the [Blazor GitHub issue tracker](https://github.com/aspnet/Blazor/issues). When filing issues, please use our [bug filing template](https://github.com/aspnet/Home/wiki/Functional-bug-template).
The best way to get your bug fixed is to be as detailed as you can be about the problem.
Providing a minimal project with steps to reproduce the problem is ideal.
Here are questions you can answer before you file a bug to make sure you're not missing any important information.

1. Did you read the [documentation](https://github.com/aspnet/blazor/wiki)?
2. Did you include the snippet of broken code in the issue?
3. What are the *EXACT* steps to reproduce this problem?
4. What specific version or build are you using?
5. What operating system are you using?

GitHub supports [markdown](https://help.github.com/articles/github-flavored-markdown/), so when filing bugs make sure you check the formatting before clicking submit.

> Note: Security issues and bugs should be reported privately, via email, to the Microsoft Security Response Center (MSRC)  secure@microsoft.com. You should receive a response within 24 hours. If for some reason you do not, please follow up via email to ensure we received your original message. Further information, including the MSRC PGP key, can be found in the [Security TechCenter](https://technet.microsoft.com/en-us/security/ff852094.aspx).

### Make a suggestion

If you have an idea for a new feature or enhancement let us know by filing an [issue](https://github.com/aspnet/blazor/issues). To help us understand and prioritize your idea please provide as much detail about your scenario and why the feature or enhancement would be useful.

### Ask questions

If you have a question be sure to first checkout our [documentation](https://github.com/aspnet/blazor/wiki). You can also ask your question on [Stack Overflow](https://stackoverflow.com/) with the [blazor](https://stackoverflow.com/questions/tagged/blazor) tag to get help from the community. But if you're still stuck, file an [issue](https://github.com/aspnet/blazor/issues) and we'll do our best to answer it.

## Contributing code and content

Blazor is an open source project and we welcome code and content contributions from the community. For details on how to submit a PR please see the ["Contributing code and content" section of the ASP.NET Contributing Guide](https://github.com/aspnet/Home/blob/dev/CONTRIBUTING.md#contributing-code-and-content).
