﻿// Copyright (c) .NET Foundation. All rights reserved.
// Licensed under the Apache License, Version 2.0. See License.txt in the project root for license information.

namespace Microsoft.AspNetCore.Blazor.Server
{
    /// <summary>
    /// Contains values for WASM-related media types.
    /// </summary>
    public static class WasmMediaTypeNames
    {
        /// <summary>
        /// Contains values for WASM-related media types within the "application." namespace
        /// </summary>
        public static class Application
        {
            /// <summary>
            /// The standard media type name for WebAssembly binary files.
            /// </summary>
            public const string Wasm = "application/wasm";
        }
    }
}
